; $LastChangedDate: 2008-07-24 17:18:01 -0500 (Thu, 24 Jul 2008) $
; $LastChangedRevision: 2397 $
; $HeadURL: svn://osiris/scheme-bos-clug/tags/2.01/1-prm-feat.scm $
;
; Some examples of primitive functions as objects
#lang scheme

(provide (all-defined-out))

(define prim-obj-creation
  (λ () 
    (λ () 
      #t)))

(define prim-obj-msg-passing
  (λ () 
    (λ (msg) 
      msg)))

(define prim-obj-lex-scope
  (λ () 
    (define x 11)
    (define y 12)
    (define frobnicate
      (λ (a b) 
        (+ a b)))
    (λ (msg) 
      (cons msg (frobnicate x y)))))

([prim-obj-creation])

([prim-obj-msg-passing] 'hello)

([prim-obj-lex-scope] 'my-message)