; $LastChangedDate: 2008-07-24 17:20:00 -0500 (Thu, 24 Jul 2008) $
; $LastChangedRevision: 2400 $
; $HeadURL: svn://osiris/scheme-bos-clug/tags/2.01/3-B-prim-obj-tsts.scm $
;
; Tests to verify that the person object is behaving as expected.
; These tests are almost identical to the primitive objects already
; presented.
#lang scheme

(require "3-A-prim-obj.scm"
         (planet "test.ss" ("schematics" "schemeunit.plt" 2 8))
         (planet "text-ui.ss" ("schematics" "schemeunit.plt" 2))
         (planet "graphical-ui.ss" ("schematics" "schemeunit.plt" 2 8)))

(provide 3-B-prim-obj-tsts)

(define 3-B-prim-obj-tsts
  (test-suite 
   "3-A-prim-obj-tsts"
   
   (test-case
    "primitive-object"
    (let ([obj (person)])
      (begin
        (check-not-false obj "creation")
        (obj 'set-age-years 27)
        (check-eq? (obj 'get-age-years) 27 "get/set age-years")
        (obj 'set-name 'Joe)
        (check-eq? (obj 'get-name) 'Joe "get/set name")
        (check-eq? (obj 'age-in-days) (* 27 365) "age-in-days"))))))