; $LastChangedDate: 2008-07-24 17:21:48 -0500 (Thu, 24 Jul 2008) $
; $LastChangedRevision: 2403 $
; $HeadURL: svn://osiris/scheme-bos-clug/tags/2.01/6-prim-obj-stx-smpl-tsts.scm $svn://osiris/scheme-bos-clug/trunk/6-prim-obj-stx-smpl-tsts.scm $
;
; Test out the person object created by the macro.
#lang scheme

(require "5-prim-obj-stx-smpl.scm"
         (planet "test.ss" ("schematics" "schemeunit.plt" 2 8))
         (planet "text-ui.ss" ("schematics" "schemeunit.plt" 2))
         (planet "graphical-ui.ss" ("schematics" "schemeunit.plt" 2 8)))

(provide 6-prim-obj-stx-smpl-tsts)

(define 6-prim-obj-stx-smpl-tsts
  (test-suite 
   "Tests for 6-prim-obj-stx-smpl-tsts"
   
   (test-case
    "define-primitive-object"
    (let ([obj (person)])
      (begin
        (check-not-false obj "creation")
        (obj 'set-age-years 27)
        (check-eq? (obj 'get-age-years) 27 "get/set age-years")
        (obj 'set-name 'Joe)
        (check-eq? (obj 'get-name) 'Joe "get/set name")
        (check-eq? (obj 'age-in-days) (* 27 365) "age-in-days")
        (check-eq? (obj 'class-name) 'person "class-name")
        (check-eq? (length (obj 'method-names)) 10 "method-names")
        (check-eq? 'person (cdr (obj 'typed-name)) "typed-name"))))))