; $LastChangedDate: 2008-07-24 17:22:07 -0500 (Thu, 24 Jul 2008) $
; $LastChangedRevision: 2404 $
; $HeadURL: svn://osiris/scheme-bos-clug/tags/2.01/all-tests.scm $
;
; Run all of the tests in presentation.
#lang scheme

(require "2-prm-feat-tsts.scm"
         "3-B-prim-obj-tsts.scm"
         "6-prim-obj-stx-smpl-tsts.scm"
         (planet "test.ss" ("schematics" "schemeunit.plt" 2 8))
         (planet "text-ui.ss" ("schematics" "schemeunit.plt" 2))
         (planet "graphical-ui.ss" ("schematics" "schemeunit.plt" 2 8)))

(provide all-demo-tests run run-ui)

(define all-demo-tests
  (test-suite 
   "All Tests for the demo"
   2-prm-feat-tsts
   3-B-prim-obj-tsts
   6-prim-obj-stx-smpl-tsts))

(define run
  (lambda ()
    (test/text-ui all-demo-tests)))

(define run-ui
  (lambda ()
    (test/graphical-ui all-demo-tests)))

(run)

