; $LastChangedDate: 2008-07-24 17:19:36 -0500 (Thu, 24 Jul 2008) $
; $LastChangedRevision: 2399 $
; $HeadURL: svn://osiris/scheme-bos-clug/tags/2.01/3-A-prim-obj.scm $
;
; This is a first attempt at implementing an object with
; variables and methods.
#lang scheme

(provide (all-defined-out))

(define person
  (λ () 
    (define name #f)
    (define age-years #f)
    
    (define set-name (λ (arg) (set! name arg)))
    (define get-name (λ () name))
    (define set-age-years (λ (arg) (set! age-years arg)))
    (define get-age-years (λ () age-years))
    
    (define age-in-days (λ () (* age-years 365)))
    
    (λ (msg . args) 
      (case msg
        [(set-name) (apply set-name args)]
        [(get-name) (get-name)]
        [(set-age-years) (apply set-age-years args)]
        [(get-age-years) (get-age-years)]
        [(age-in-days) (age-in-days)]
        [else (error "message not understood" msg)]))))